program CalcTable;

{$APPTYPE CONSOLE}

uses
  SysUtils;

var vav, range, vsav: real;
  be, ba, bs, baa, bi, bz, bzz, bava, bavs: real;
  outf: textfile;
  v: array[1..10] of real;

function threedecimals(x:real): shortstring;
var xx: integer;
begin
  xx := abs(round(1000*(x - trunc(x))));
  case xx of
  0: result := '000';
  1..9: result := '00'+inttostr(xx);
  10..99: result := '0'+inttostr(xx);
  else result := inttostr(xx);
  end;
end;

function twodecimals(x:real): shortstring;
var xx: integer;
begin
  xx := abs(round(100*(x - trunc(x))));
  case xx of
  0: result := '00';
  1..9: result := '0'+inttostr(xx);
  else result := inttostr(xx);
  end;
end;

procedure contr_simi(k: integer);
var i,j: integer;
procedure cs(zi,zj: real);
var cs: real;
begin
  cs := be*(zi-vav) + ba*(zj-vav) + bs*(1 - (abs(zi-zj)/range) - vsav);
  if (cs < 0.0) then write(outf,'--') else write(outf,'  ');
  write(outf,abs(trunc(cs)),'&',twodecimals(cs),'  ');
//  write(outf,'(',cs:7:3,')');  // check
end; (* cs *)
begin (* contr_simi *)
  writeln(outf,'similarity');
  writeln(outf);
  writeln(outf,'\begin{center}');
  write(outf,'\begin{tabular}{l');
  for i:=1 to k do write(outf,' r@{.}l ');
  writeln(outf,'}');
  write(outf,'$ z_i \ \  \backslash  \ \ z_j $   &  ');
  for i:=1 to k-1 do write(outf,'\mcc{2}{',v[i]:2:0,'} & ');
  writeln(outf,' \mcc{2}{',v[k]:2:0,'}');
  writeln(outf,'\separationb');

  for i:=1 to k do
    begin
    write(outf,v[i]:2:0,'      ');
    for j:=1 to k do
      begin
      write(outf,'  &  ');
      cs(v[i],v[j]);
      end;
    writeln(outf,' \\');
    end;

  writeln(outf,'\hline');
  writeln(outf,'\end{tabular}');
  writeln(outf,'\end{center}');

  writeln(outf);
end; (* contr_simi *)

procedure contr_inter(k: integer);
var i,j: integer;
procedure ci(zi,zj: real);
var cs: real;
begin
  cs := be*(zi-vav) + ba*(zj-vav) + baa*(zj-vav)*(zj-vav)
        + bi*(zi-vav)*(zj-vav);
  if (cs < 0.0) then write(outf,'--') else write(outf,'  ');
  write(outf,abs(trunc(cs)),'&',twodecimals(cs),'  ');
//  write(outf,'(',cs:7:3,')');  // check
end; (* cs *)
begin (* contr_inter *)
  writeln(outf,'interaction');
  writeln(outf);
  writeln(outf,'\begin{center}');
  write(outf,'\begin{tabular}{l');
  for i:=1 to k do write(outf,' r@{.}l ');
  writeln(outf,'}');
  write(outf,'$ z_i \ \  \backslash  \ \ z_j $   &  ');
  for i:=1 to k-1 do write(outf,'\mcc{2}{',v[i]:2:0,'} & ');
  writeln(outf,' \mcc{2}{',v[k]:2:0,'}');
  writeln(outf,'\separationb');

  for i:=1 to k do
    begin
    write(outf,v[i]:2:0,'      ');
    for j:=1 to k do
      begin
      write(outf,'  &  ');
      ci(v[i],v[j]);
      end;
    writeln(outf,' \\');
    end;

  writeln(outf,'\hline');
  writeln(outf,'\end{tabular}');
  writeln(outf,'\end{center}');

  writeln(outf);
end; (* contr_inter *)

procedure contr_avalt(k: integer);
// roles of i and j transposed here
var i,j: integer;
procedure ci(zi,zj: real);
var cs: real;
begin
  cs :=  bz*(zi-vav) + bzz*(zi-vav)*(zi-vav)
        + bava*(zi-vav)*(zj-vav);
  if (cs < 0.0) then write(outf,'--') else write(outf,'  ');
  write(outf,abs(trunc(cs)),'&',twodecimals(cs),'  ');
//  write(outf,'(',cs:7:3,')');  // check
end; (* ci*)
begin (* contr_avalt *)
  writeln(outf,'average alter');
  writeln(outf);
  writeln(outf,'\begin{center}');
  write(outf,'\begin{tabular}{l');
  for i:=1 to k do write(outf,' r@{.}l ');
  writeln(outf,'}');
  write(outf,' $\bar z_{(i)}$ \ \  \backslash  \ \ $z_i $   &  ');
  for i:=1 to k-1 do write(outf,'\mcc{2}{',v[i]:2:0,'} & ');
  writeln(outf,' \mcc{2}{',v[k]:2:0,'}');
  writeln(outf,'\separationb');

// i and j interchanged:
  for j:=1 to k do
    begin
    write(outf,v[j]:2:0,'      ');
    for i:=1 to k do
      begin
      write(outf,'  &  ');
      ci(v[i],v[j]);
      end;
    writeln(outf,' \\');
    end;

  writeln(outf,'\hline');
  writeln(outf,'\end{tabular}');
  writeln(outf,'\end{center}');

  writeln(outf);
end; (* contr_avalt *)

procedure contr_avsim(k: integer);
// roles of i and j transposed here
var i,j: integer;
procedure ci(zi,zj: real);
var cs: real;
begin
  cs := be*(zi-vav) + ba*(zj-vav) + bs*(1 - (abs(zi-zj)/range) - vsav);

  cs :=  bz*(zi-vav) + bzz*(zi-vav)*(zi-vav)
     + bavs*(1 - (abs(zi-zj)/range) - vsav);
  if (cs < 0.0) then write(outf,'--') else write(outf,'  ');
  write(outf,abs(trunc(cs)),'&',twodecimals(cs),'  ');
//  write(outf,'(',cs:7:3,')');  // check
end; (* ci*)
begin (* contr_avsim *)
  writeln(outf,'average similarity ');
  writeln(outf);
  writeln(outf,'\begin{center}');
  write(outf,'\begin{tabular}{l');
  for i:=1 to k do write(outf,' r@{.}l ');
  writeln(outf,'}');
  write(outf,' $\bar z_{(i)}$ \ \ $ \backslash $ \ \ $z_i $   &  ');
  for i:=1 to k-1 do write(outf,'\mcc{2}{',v[i]:2:0,'} & ');
  writeln(outf,' \mcc{2}{',v[k]:2:0,'}');
  writeln(outf,'\separationb');

// i and j interchanged:
  for j:=1 to k do
    begin
    write(outf,v[j]:2:0,'      ');
    for i:=1 to k do
      begin
      write(outf,'  &  ');
      ci(v[i],v[j]);
      end;
    writeln(outf,' \\');
    end;

  writeln(outf,'\hline');
  writeln(outf,'\end{tabular}');
  writeln(outf,'\end{center}');

  writeln(outf);
end; (* contr_avsim *)

begin
{  v[1] := 1.0;
  v[2] := 2.0;
  v[3] := 3.0;
  v[4] := 4.0;
  v[5] := 5.0;
  vav := 3.113;
  range := 4.0;
  vsav := 0.6983;
 }


  v[1] := 1;
  v[2] := 2;
  v[3] := 3;
  v[4] := 4;
  v[5] := 5;
  vav := 1.5;
  range := 3.0;
  vsav := 0.7533;

  assign(outf,'calctable.out');
  rewrite(outf);



{  be :=  -0.01;
  ba :=   0.0899;
  bs :=   0.8994;
 }
{    be :=  0.1362;
  ba :=   -0.1295;
  bs :=   0.665;
  contr_simi(4);
}
{  be := 0.0078;
  ba := 0.1041;
  baa := 0.0078;
  bi := 0.1655;
}

  be := -0.0214;
  ba := -0.2603;
  baa := -0.0249;
  bi := 0.1976;


  vav := 3.113;
  bz := 0.382;
  bzz := -0.5428;
  bava := 1.1414;

  contr_avalt(5);

  bz := 0.3618;
  bzz := -0.06;
  bavs := 3.9689;
  contr_avsim(5);
  closefile(outf);

end.
