unit siena_1;


interface


uses
{$if not defined(linux)}
  Windows,
{$ifend}
Messages, SysUtils, Classes, Forms,
 {$if defined(lazarus)}
  lresources,
 {$ifend}
  slib, s_start, s_base, s_dat, StdCtrls, Controls, Graphics, ExtCtrls,s_constants;

   procedure TinitFormFormActivate();
type
  TInitForm = class(TForm)
    MessageLabel: TLabel;
    SienaIcon: TImage;
  // procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
  public
        { Public declarations }
  end;

var
  InitForm: TInitForm;

  outfile,lf: TFileStream;
    st1, logfile, proname: shortstring;
    ReadDigraph: Readgraph;   (* in S_Start *)
    ContinueDigraph: ModelSpecification; (* in S_Base *)
    halter: Boolean; (* halt error indicator *)
    x : string;
implementation

{$if not defined(lazarus) then}
{$R *.dfm}
{$ifend}
procedure TInitFormFormActivate();
begin
  Application.ProcessMessages;
  CallingProgram := 1;
  simulate := false;
  st1 := ParamStr(1);
  proname := st1;
  InitForm.caption := 'Siena Initialisation <'+proname+'>';
  with ReadDigraph
  do begin
    Preparations(proname,halter,outfile,lf);
(* AA change *)  if not halter then ChangeDefaults;
    FinishDat(outfile);
  end;
  Application.ProcessMessages;
  if (not halter)
  then begin
    with ContinueDigraph
    do begin
    (* The next commands are functionally equivalent to procedure AttachProject,
       but without the attachment of the output files.
       They are necessary because ReadDigraph and ContinueDigraph
       are non-comparable objects.
       The double call of ReadDefinition is not elegant but convenient.
        *)
      Heading(2,lf,'Describe Model Options.');
      initialise;
      pname := proname;
      InitForm.MessageLabel.caption := '.. describe model options';
      Application.ProcessMessages;
{$if defined(batch)}
      Writeln(Initform.MessageLabel.caption);
{$ifend}

      if (not halter) then ReadDefinition1(halter,outfile,lf);
      if (not halter) then ReadPData(halter,outfile,lf);
      if (not halter) then ReadDefinition2(proname,halter,outfile,lf);
      if (not halter) then InitialiseBase1(outfile,lf);
      if (not halter) then ReviseDefinition(halter,outfile,lf);
      if (not halter) then DefineFunctions(outfile,lf);
      if (not halter) then DescribeModelOptions(outfile,lf);
      if (not halter) then DeActivateModel(outfile);
     end;
    if (FoundError or halter)
    then begin
      x := 'An error occurred in the initialisation of project <<'+proname+'>> .'+eol;
      outfile.Write(pchar(x)^,length(x));
    end
    else begin
      x := 'Initialisation of project <<'+proname+'>> executed succesfully.'+eol;
      outfile.Write(pchar(x)^,length(x));
    end;
  end;

  Application.ProcessMessages;
  outfile.Write(pchar(eol)^,length(eol));
  outfile.free;
  lf.free;
end;
{$if defined(lazarus)}
initialization
{$I siena_1.lrs}
{$else}
begin
{$ifend}
end.
