unit siena_4;                      (* siena4.pas *)

(* The purpose of this program is to keep the .MO file,
   in particular the names of effects, consistent
   when parameter values are changed. *)

interface

uses classes, slib, s_base, SysUtils, s_dat, s_constants;
procedure doit;
var outfile,lf: TFileStream;
    st1, st2: shortstring;
    ContinueDigraph: ModelSpecification;
    apf,halter: boolean;
    x: string;

implementation
procedure doit();
begin
  CallingProgram := 4;
  simulate := false;
  st1 := ParamStr(1);
  apf := true;
  halter := false;
  if (ParamCount >= 2) then st2 := ParamStr(2) else st2 := st1;
  with ContinueDigraph do begin
    AttachProject(st1,st2,halter,outfile,lf, apf, false);
    InitialiseBase1(outfile,lf);
    if (not halter) then begin
      ReviseDefinition(halter,outfile,lf);
      DefineFunctions(outfile,lf);
      x := 'SIENA04'+eol;
      lf.Write(pchar(x)^,length(x));
      x := 'Date and time: '+DateTimeToStr(Now)+eol;
      lf.Write(pchar(x)^,length(x));
      Heading(1,lf,'Internal bookkeeping.');
      if (ParamCount >= 2) and (st1 <> st2) then
        begin
        Heading(2,lf,'Copy model definition from project '+st2+'.');
        x := 'SIENA04'+eol;
        outfile.Write(pchar(x)^,length(x));
        x := 'Date and time: '+DateTimeToStr(Now)+eol;
        outfile.Write(pchar(x)^,length(x)) ;
        Heading(1,outfile,'Copy model definition');
        x := 'The entire model definition, including current parameter values,'+eol;
        outfile.Write(pchar(x)^,length(x));
        x := 'is copied from project '+st2+'.'+eol;
        outfile.Write(pchar(x)^,length(x));
        end
       else
        Heading(2,lf,'Make description file '+pname+'.MO consistent.');
//      AdaptModel(outfile);
      WriteDefinitionModel(lf);
      WriteDefinitionStats(lf);
    end;
   end;
  //closefile(outfile);
  //closefile(lf);
  outfile.free;
  lf.free;
  end;
end.
